dnl
dnl Doozer++ is (C) Copyright 2000, 2001 by Iowa State University
dnl
dnl Original Author:
dnl   Patrick Hartling
dnl
dnl This library is free software; you can redistribute it and/or
dnl modify it under the terms of the GNU Library General Public
dnl License as published by the Free Software Foundation; either
dnl version 2 of the License, or (at your option) any later version.
dnl
dnl This library is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl Library General Public License for more details.
dnl
dnl You should have received a copy of the GNU Library General Public
dnl License along with this library; if not, write to the
dnl Free Software Foundation, Inc., 59 Temple Place - Suite 330,
dnl Boston, MA 02111-1307, USA.

dnl ---------------------------------------------------------------------------
dnl Generate a script called 'reconfig'.  This script cleans out all the files
dnl generated by configure in a build directory.  It then runs configure again
dnl using the same arguments given to it when the script was generated.
dnl
dnl Usage:
dnl     DPP_GEN_RECONFIG
dnl ---------------------------------------------------------------------------

AC_DEFUN(DPP_GEN_RECONFIG,
[
    dnl Create a script for handy reconfiguration of a build tree.  It removes
    dnl configure's cache and status files and then runs configure with the
    dnl same arguments.
    : ${RECONFIG=./reconfig}

    echo "creating $RECONFIG"
    rm -f $RECONFIG

[
    cat > $RECONFIG <<RECONFIG_SCRIPT
rm -f config.status config.cache config.log
${0} $ac_configure_args
RECONFIG_SCRIPT
]

    chmod +x $RECONFIG
])
