/* ------------------------------------------------------------------------
 * $Id: ViewSlotImpl.cc,v 1.5 2001/06/17 17:29:10 elm Exp $
 *
 * This file is part of 3Dwm: The Three-Dimensional User Environment.
 *
 * 3Dwm: The Three-Dimensional User Environment:
 *	<http://www.3dwm.org>
 *
 * Chalmers Medialab
 * 	<http://www.medialab.chalmers.se>
 * 
 * ------------------------------------------------------------------------
 * File created 2000-11-22 by Niklas Elmqvist.
 *
 * Copyright (c) 2000 Niklas Elmqvist <elm@3dwm.org>.
 * Copyright (c) 2000 Steve Houston <shouston@programmer.net>.
 * ------------------------------------------------------------------------
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * ------------------------------------------------------------------------
 */

// -- 3Dwm Includes
#include "Celsius/Mutex.hh"
#include "Polhem/TransformImpl.hh"
#include "Polhem/VisitorImpl.hh"
#include "Polhem/NodeImpl.hh"
#include "Polhem/ViewSlotImpl.hh"

using namespace Nobel;

// -- Code Segment

ViewSlotImpl::ViewSlotImpl()
    : _transform(new TransformImpl)
{
    // empty
}

ViewSlotImpl::~ViewSlotImpl()
{
    deactivate(_transform);
    delete _transform;    
}

Nobel::Transform_ptr ViewSlotImpl::transformation()
{
    return _transform->_this();    
}

void ViewSlotImpl::traverse(Nobel::Visitor_ptr v)
{
    // empty (no children in the view slot)
}

void ViewSlotImpl::render(Nobel::Renderer_ptr r)
{
    // empty (nothing to render)
}

void ViewSlotImpl::pick(Nobel::Picker_ptr p)
{
    // empty (nothing to pick)
}
